#!/bin/bash 
# 
# Call this script from a kickstart post, for example in Satellite 
# Just add this one line as your script: 
# wget -O - http://sysman-thel6.refarch.bos.redhat.com/cobbler/scripts/refarch-common-post.sh | /bin/bash 

LOGFILE=/root/refarch-common-post-`hostname -s`-`date +%F_%T`.log 
( 

# get redeploy for future use 
if [ ! -d /usr/local/bin ] 
then 
  echo making /usr/local/bin 
  mkdir -p /usr/local/bin 
fi 
wget http://sysman-rhel6.refarch.bos.redhat.com/cobbler/scripts/redeploy -O /usr/local/bin/redeploy 
chmod +x /usr/local/bin/redeploy 

# Adding group bashrc 
wget http://sysman-rhel6.refarch.bos.redhat.com/cobbler/scripts/bashrc -O /etc/profile.d/refarch-bashrc.sh 

# Fix SELinux issues with the /root/.ssh directory and files. 
restorecon -r /root/.ssh 

# Importing gpg key for custom RHN channel/packages 
wget http://sysman-rhel6.refarch.bos.redhat.com/cobbler/scripts/public_key.txt -O /root/public_key.txt 
rpm --import /root/public_key.txt 

# Adding packages that should always be installed 
# echo -Adding vital packages 
spacewalk-channel --add -c rhel-x86_64-rhev-agent-6-server-beta -c web-server-content --user admin --password [REDACTED] 
yum -y install screen firefox nfs-utils xorg-x11-xauth autofs sg3_utils policycoreutils-python rhevm-guest-agent web-1-1 
yum -y groupinstall @network-file-system-client 
chkconfig httpd on 
# full system update 
echo -Running full update ... 
yum -y update 

) 2>&1 | tee ${LOGFILE} 
echo Done with [refarch-common-post]. Wrote logfile: ${LOGFILE}
