# Kickstart config file generated by RHN Satellite Config Management
# Profile Label : websrv
# Date Created  : 2013-05-15 13:38:45.0

install
text
network --bootproto dhcp
url --url http://sysman-rhel6.refarch.bos.redhat.com/ks/dist/ks-rhel-x86_64-server-6-6.4
lang en_US
keyboard us
zerombr
clearpart --all
bootloader --location mbr
timezone America/New_York
auth --enablemd5 --enableshadow
rootpw --iscrypted [REDACTED]
selinux --enforcing
poweroff
firewall --enabled --http --ssh
skipx
part /boot --fstype=ext3 --size=200 
part pv.01 --size=1000 --grow 
part swap --size=1000   --maxsize=2000 
volgroup myvg pv.01 
logvol / --vgname=myvg --name=rootvol --size=1000 --grow

%packages 
@ Base
@ Web Server
%end

%pre

wget "http://sysman-rhel6.refarch.bos.redhat.com/cblr/svc/op/trig/mode/pre/profile/websrv:1:RedHatGSS" -O /dev/null

echo "Saving RHN keys..." > /dev/ttyS0
SYSTEM_ID=/etc/sysconfig/rhn/systemid
rhn_keys_found=no

mkdir -p /tmp/rhn

drives=$(list-harddrives | awk '{print $1}')
for disk in $drives; do
    DISKS="$DISKS $(fdisk -l /dev/$disk | grep -v "swap\|LVM\|Extended" | awk '/^\/dev/{print $1}')"
done

# Try to find the keys on ordinary partitions
for disk in $DISKS; do
    name=test-$(basename $disk)
    mkdir -p /tmp/$name
    mount $disk /tmp/$name
    [ $? -eq 0 ] || continue # Skip to the next partition if the mount fails

    # Copy current RHN host keys out to be reused
    if [ -f /tmp/${name}$SYSTEM_ID ]; then
        cp -a /tmp/${name}$SYSTEM_ID /tmp/rhn
        rhn_keys_found="yes"
        umount /tmp/$name
        break
    fi
    umount /tmp/$name
    rm -r /tmp/$name
done

# Try LVM if that didn't work
if [ "$rhn_keys_found" = "no" ]; then
    lvm lvmdiskscan
    vgs=$(lvm vgs | tail -n +2 | awk '{ print $1 }')
    for vg in $vgs; do
        # Activate any VG we found
        lvm vgchange -ay $vg
    done
    
    lvs=$(lvm lvs | tail -n +2 | awk '{ print "/dev/" $2 "/" $1 }')
    for lv in $lvs; do
        tmpdir=$(mktemp -d findkeys.XXXXXX)
        mkdir -p /tmp/${tmpdir}
        mount $lv /tmp/${tmpdir} || continue # Skip to next volume if this fails

        # Let's see if the keys are in there
        if [ -f /tmp/${tmpdir}$SYSTEM_ID ]; then
            cp -a /tmp/${tmpdir}$SYSTEM_ID /tmp/rhn/
            rhn_keys_found="yes"
            umount /tmp/${tmpdir}
            break # We're done!
        fi
        umount /tmp/${tmpdir}
        rm -r /tmp/${tmpdir}
    done
    
    # And clean up..
    for vg in $vgs; do
        lvm vgchange -an $vg
    done
fi


%end

%post --nochroot
mkdir /mnt/sysimage/tmp/ks-tree-copy
if [ -d /oldtmp/ks-tree-shadow ]; then
cp -fa /oldtmp/ks-tree-shadow/* /mnt/sysimage/tmp/ks-tree-copy
elif [ -d /tmp/ks-tree-shadow ]; then
cp -fa /tmp/ks-tree-shadow/* /mnt/sysimage/tmp/ks-tree-copy
fi
cp /etc/resolv.conf /mnt/sysimage/etc/resolv.conf
cp -f /tmp/ks-pre.log* /mnt/sysimage/root/ || :

%end

%post --nochroot --interpreter /usr/bin/python
try:
    import xmlrpclib
    import shutil
    import sys
    import os.path
    old_system_id = "/tmp/rhn/systemid"
    new_system_id = "/mnt/sysimage/root/systemid.old"

    new_keys = "1-0a0f4ef8d13b562899298b13379849a1"
    for key in new_keys.split(','):
        if key.startswith('re-'):
            sys.exit(0)
    if os.path.exists(old_system_id):
        client =  xmlrpclib.Server("http://sysman-rhel6.refarch.bos.redhat.com/rpc/api")
        key = client.system.obtain_reactivation_key(open(old_system_id).read())
        f = open("/mnt/sysimage/tmp/key","w")
        f.write(key)
        f.close()
        shutil.copy(old_system_id, new_system_id)
except:
    # xml rpc due to  a old/bad system id
    # we don't care about those
    # we'll register those as new.
    pass


%end

%post --log /root/ks-rhn-post.log
# --Begin RHN Satellite command section--
cat > /tmp/ssl-key-1 <<'EOF'
<content removed for brevity>

EOF
# ssl-key1
cat /tmp/ssl-key-* > /usr/share/rhn/RHN-ORG-TRUSTED-SSL-CERT
perl -pe 's/RHNS-CA-CERT/RHN-ORG-TRUSTED-SSL-CERT/g' -i /etc/sysconfig/rhn/up2date

mkdir -p /tmp/rhn_rpms/optional
cd /tmp/rhn_rpms/optional 
wget -P /tmp/rhn_rpms/optional http://sysman-rhel6.refarch.bos.redhat.com/download/package/9de1af573ec5a107deb533595326d50f520b035d/0/1/5953/rhnlib-2.5.22-12.el6.noarch.rpm http://sysman-rhel6.refarch.bos.redhat.com/download/package/8f77f155032b253f003aa27107b61c5f8d99877f/0/1/2079/pyOpenSSL-0.10-2.el6.x86_64.rpm http://sysman-rhel6.refarch.bos.redhat.com/download/package/b5397d7f2a005d985c32304ef5758df4e6b464f1/0/1/10095/libxml2-python-2.7.6-12.el6_4.1.x86_64.rpm 
rpm -Uvh --replacepkgs --replacefiles /tmp/rhn_rpms/optional/pyOpenSSL* /tmp/rhn_rpms/optional/rhnlib* /tmp/rhn_rpms/optional/libxml2-python* 
perl -npe 's|^(\s*(noSSLS\|s)erverURL\s*=\s*[^:]+://)[^/]*/|${1}sysman-rhel6.refarch.bos.redhat.com/|' -i /etc/sysconfig/rhn/up2date

# now copy from the ks-tree we saved in the non-chroot checkout
cp -fav /tmp/ks-tree-copy/* /
rm -Rf /tmp/ks-tree-copy
# --End RHN Satellite command section--

# begin cobbler snippet
# set default MOTD
echo "Kickstarted on $(date +'%Y-%m-%d')" >> /etc/motd

# begin Red Hat management server registration
mkdir -p /usr/share/rhn/
wget http://sysman-rhel6.refarch.bos.redhat.com/pub/RHN-ORG-TRUSTED-SSL-CERT -O /usr/share/rhn/RHN-ORG-TRUSTED-SSL-CERT   
perl -npe 's/RHNS-CA-CERT/RHN-ORG-TRUSTED-SSL-CERT/g' -i /etc/sysconfig/rhn/*  
if [ -f /etc/pki/rpm-gpg/RPM-GPG-KEY-redhat-release ]; then
    rpm --import /etc/pki/rpm-gpg/RPM-GPG-KEY-redhat-release
fi
key=""
if [ -f /tmp/key ]; then
    key=`cat /tmp/key`
fi

if [ $key ]; then 
    rhnreg_ks --serverUrl=https://sysman-rhel6.refarch.bos.redhat.com/XMLRPC --sslCACert=/usr/share/rhn/RHN-ORG-TRUSTED-SSL-CERT --activationkey=$key,1-0a0f4ef8d13b562899298b13379849a1
else
     rhnreg_ks --serverUrl=https://sysman-rhel6.refarch.bos.redhat.com/XMLRPC --sslCACert=/usr/share/rhn/RHN-ORG-TRUSTED-SSL-CERT --activationkey=1-0a0f4ef8d13b562899298b13379849a1
fi
# end Red Hat management server registration

# end cobbler snippet

rhn_check

# Start post_install_network_config generated code
# End post_install_network_config generated code

%end


%post
#Please edit this script on sysman-rhel6 under /scripts
wget -O - http://sysman-rhel6.refarch.bos.redhat.com/cobbler/scripts/refarch-common-post.sh | /bin/bash
%end

%post


# Start koan environment setup
echo "export COBBLER_SERVER=sysman-rhel6.refarch.bos.redhat.com" > /etc/profile.d/cobbler.sh
echo "setenv COBBLER_SERVER sysman-rhel6.refarch.bos.redhat.com" > /etc/profile.d/cobbler.csh
# End koan environment setup


wget "http://sysman-rhel6.refarch.bos.redhat.com/cblr/svc/op/ks/profile/websrv:1:RedHatGSS" -O /root/cobbler.ks
wget "http://sysman-rhel6.refarch.bos.redhat.com/cblr/svc/op/trig/mode/post/profile/websrv:1:RedHatGSS" -O /dev/null

%post
#CFME Deployment Status
wget --no-check-certificate <%= evm[:callback_url_on_post_install] %>
%end
